/**********************************************************************
* file:   testpcap2.c
* date:   2001-Mar-14 12:14:19 AM
* Author: Martin Casado
* Last Modified:2001-Mar-14 12:14:11 AM
*
* Description: Q&D proggy to demonstrate the use of pcap_loop
*
**********************************************************************/

#include <pcap.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/if_ether.h>

#include <signal.h>

typedef struct  {
    pcap_dumper_t* dumper;
} callback_data_t;

callback_data_t cd;

/* callback function that is passed to pcap_loop(..) and called each time
 * a packet is recieved                                                    */
void my_callback(u_char *cd_u, const struct pcap_pkthdr* pkthdr, const u_char*
        packet)
{
    static int count = 1;
    fprintf(stdout,"%d: %lu\n", count, sizeof(packet));
    if(count == 4)
        fprintf(stdout,"Come on baby sayyy you love me!!! ");
    if(count == 7)
        fprintf(stdout,"Tiiimmmeesss!! ");
    fflush(stdout);
    count++;
    pcap_dump((u_char*)cd.dumper, pkthdr, packet);

}

void cleanup() {
    pcap_dump_close(cd.dumper);
    // should stop pcap as well
    exit(0);
}

void int_handler(int signal) {
    printf("[XX] interrupted. Signal: %d\n", signal);
    cleanup();
}

int main(int argc,char **argv)
{
    //int i;
    char *dev;
    char errbuf[PCAP_ERRBUF_SIZE];
    pcap_t* descr;
    //const u_char *packet;
    //struct pcap_pkthdr hdr;     /* pcap.h */
    //struct ether_header *eptr;  /* net/ethernet.h */

    if(argc != 2){ fprintf(stdout,"Usage: %s numpackets\n",argv[0]);return 0;}

    /* grab a device to peak into... */
    dev = pcap_lookupdev(errbuf);
    if(dev == NULL) {
        printf("%s\n",errbuf); exit(1);
    }
    /* open device for reading */
    descr = pcap_open_live(dev, BUFSIZ, 0, -1, errbuf);
    if(descr == NULL) {
        printf("pcap_open_live(): %s\n", errbuf);
        exit(1);
    }

    cd.dumper = pcap_dump_open(descr, "/tmp/dump.pcap");
    if (cd.dumper == NULL) {
        printf("fopen() failed\n");
        exit(1);
    }

    signal(SIGINT, int_handler);
    signal(SIGKILL, int_handler);

    /* allright here we call pcap_loop(..) and pass in our callback function */
    /* int pcap_loop(pcap_t *p, int cnt, pcap_handler callback, u_char *user)*/
    /* If you are wondering what the user argument is all about, so am I!!   */
    pcap_loop(descr, atoi(argv[1]), my_callback, (u_char*)&cd);

    cleanup();
    fprintf(stdout,"\nDone processing packets... wheew!\n");
    return 0;
}

